# Nuclear Energy Plant Radiation Plugin

This project was developed on the course of the Geographic Information System (GIS) of the master's degree program in data science at the University of Salerno. The goal of this project was develop a python plugin for the software Quantum GIS (QGIS) in order to visualize on the open street map all nuclear energy plant in the world. This plugin use the mqtt protocol for receive of radiation data from sensors in order to dinamically visualize it on the map. In order to clarify the visualization of the radiation data, a heat map was created and used. The plugin uses fake radiation, it simulates that the data comes from real sensors. The extention value (radiation radius) is computed by MAX_RADIATION_VALUE / (4pi), in order to give a real visual experience.


## Getting started

These instructions will get you a copy of the project up and running on your local machine for development and testing purposes. See 
deployment for notes on how to deploy the project on a live system.


### Prerequisites

First of all, you will need a machine running QGIS (it is available for Windows, Linux, MacOS. Android, FreeBSD ) and it must be allow multithreading.

What things you need to install the software and how to install them

*	Download and install QGIS software from here: https://www.qgis.org/it/site/forusers/download.html
*	Download and install git from here: https://git-scm.com/book/en/v2/Getting-Started-Installing-Git
*	We suggest download of 'Pycharm' IDE from here: https://www.jetbrains.com/pycharm/download/#section=linux



### Installing

A step by step series that tell you how to get a development env running

#### Clone energy_plant_radiation_module project ####

1. Open your git shell

2. Execute the following command: `git clone https://github.com/DomenicoM92/energy_plant_radiation_module.git`

#### QGIS Software: ####

1.	Open your QGIS.

2.	Go to Plugin.

3.	Go to Manage and install plugin

4.	Search energy_plant plugin and add it

## Deployment
1.	Follow the previous instructions
2.	Open qgis and run the energy_plant plugin


## Authors

Project manager: 
* **Domenico Marino** - *Energy_Plant Plugin* - [DomenicoM92](https://github.com/DomenicoM92)
* **Ruggiero Mario** - *Energy_Plant Plugin* - [MarioR95](https://github.com/MarioR95)

## License

This project is totally open source and free to use.
